# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from firehydrant_api_client.models.put_v1_incidents_incident_id_impact_status_pages_inner import PutV1IncidentsIncidentIdImpactStatusPagesInner
from typing import Optional, Set
from typing_extensions import Self

class PostV1IncidentsIncidentIdNotes(BaseModel):
    """
    Create a new note on for an incident. The visibility field on a note determines where it gets posted.
    """ # noqa: E501
    body: StrictStr
    occurred_at: Optional[datetime] = Field(default=None, description="ISO8601 timestamp for when the note occurred")
    visibility: Optional[StrictStr] = 'private_to_org'
    status_pages: Optional[List[PutV1IncidentsIncidentIdImpactStatusPagesInner]] = None
    __properties: ClassVar[List[str]] = ["body", "occurred_at", "visibility", "status_pages"]

    @field_validator('visibility')
    def visibility_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['private_to_org', 'open_to_public', 'internal_status_page']):
            raise ValueError("must be one of enum values ('private_to_org', 'open_to_public', 'internal_status_page')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostV1IncidentsIncidentIdNotes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in status_pages (list)
        _items = []
        if self.status_pages:
            for _item_status_pages in self.status_pages:
                if _item_status_pages:
                    _items.append(_item_status_pages.to_dict())
            _dict['status_pages'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostV1IncidentsIncidentIdNotes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "body": obj.get("body"),
            "occurred_at": obj.get("occurred_at"),
            "visibility": obj.get("visibility") if obj.get("visibility") is not None else 'private_to_org',
            "status_pages": [PutV1IncidentsIncidentIdImpactStatusPagesInner.from_dict(_item) for _item in obj["status_pages"]] if obj.get("status_pages") is not None else None
        })
        return _obj


