# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PostV1TeamsTeamIdOnCallSchedulesStrategy(BaseModel):
    """
    An object that specifies how the schedule's on-call shifts should be generated.
    """ # noqa: E501
    type: StrictStr = Field(description="The type of strategy. Must be one of \"daily\", \"weekly\", or \"custom\".")
    handoff_time: Optional[StrictStr] = Field(default=None, description="An ISO8601 time string specifying when on-call shifts should hand off. This value is only used if the strategy type is \"daily\" or \"weekly\".")
    handoff_day: Optional[StrictStr] = Field(default=None, description="The day of the week on which on-call shifts should hand off, as its long-form name (e.g. \"monday\", \"tuesday\", etc). This value is only used if the strategy type is \"weekly\".")
    shift_duration: Optional[StrictStr] = Field(default=None, description="An ISO8601 duration string specifying how long each shift should last. This value is only used if the strategy type is \"custom\".")
    __properties: ClassVar[List[str]] = ["type", "handoff_time", "handoff_day", "shift_duration"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['daily', 'weekly', 'custom']):
            raise ValueError("must be one of enum values ('daily', 'weekly', 'custom')")
        return value

    @field_validator('handoff_day')
    def handoff_day_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday', 'sunday']):
            raise ValueError("must be one of enum values ('monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday', 'sunday')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostV1TeamsTeamIdOnCallSchedulesStrategy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostV1TeamsTeamIdOnCallSchedulesStrategy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "handoff_time": obj.get("handoff_time"),
            "handoff_day": obj.get("handoff_day"),
            "shift_duration": obj.get("shift_duration")
        })
        return _obj


