# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from firehydrant_api_client.models.post_v1_runbooks_attachment_rule import PostV1RunbooksAttachmentRule
from firehydrant_api_client.models.put_v1_runbooks_runbook_id_owner import PutV1RunbooksRunbookIdOwner
from firehydrant_api_client.models.put_v1_runbooks_runbook_id_severities_inner import PutV1RunbooksRunbookIdSeveritiesInner
from firehydrant_api_client.models.put_v1_runbooks_runbook_id_steps_inner import PutV1RunbooksRunbookIdStepsInner
from typing import Optional, Set
from typing_extensions import Self

class PutV1RunbooksRunbookId(BaseModel):
    """
    Update a runbook and any attachment rules associated with it. This endpoint is used to configure nearly everything about a runbook, including but not limited to the steps, environments, attachment rules, and severities. 
    """ # noqa: E501
    name: Optional[StrictStr] = None
    summary: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    tutorial: Optional[StrictBool] = Field(default=None, description="Whether or not this runbook is a tutorial runbook")
    owner: Optional[PutV1RunbooksRunbookIdOwner] = None
    severities: Optional[List[PutV1RunbooksRunbookIdSeveritiesInner]] = None
    services: Optional[List[PutV1RunbooksRunbookIdSeveritiesInner]] = None
    environments: Optional[List[PutV1RunbooksRunbookIdSeveritiesInner]] = None
    attachment_rule: Optional[PostV1RunbooksAttachmentRule] = None
    steps: Optional[List[PutV1RunbooksRunbookIdStepsInner]] = None
    auto_attach_to_restricted_incidents: Optional[StrictBool] = Field(default=None, description="Whether or not this runbook should be automatically attached to restricted incidents. Note that setting this to `true` will prevent it from being attached to public incidents, even manually. Defaults to `false`.")
    __properties: ClassVar[List[str]] = ["name", "summary", "description", "tutorial", "owner", "severities", "services", "environments", "attachment_rule", "steps", "auto_attach_to_restricted_incidents"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PutV1RunbooksRunbookId from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of owner
        if self.owner:
            _dict['owner'] = self.owner.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in severities (list)
        _items = []
        if self.severities:
            for _item_severities in self.severities:
                if _item_severities:
                    _items.append(_item_severities.to_dict())
            _dict['severities'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in services (list)
        _items = []
        if self.services:
            for _item_services in self.services:
                if _item_services:
                    _items.append(_item_services.to_dict())
            _dict['services'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in environments (list)
        _items = []
        if self.environments:
            for _item_environments in self.environments:
                if _item_environments:
                    _items.append(_item_environments.to_dict())
            _dict['environments'] = _items
        # override the default output from pydantic by calling `to_dict()` of attachment_rule
        if self.attachment_rule:
            _dict['attachment_rule'] = self.attachment_rule.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in steps (list)
        _items = []
        if self.steps:
            for _item_steps in self.steps:
                if _item_steps:
                    _items.append(_item_steps.to_dict())
            _dict['steps'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PutV1RunbooksRunbookId from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "summary": obj.get("summary"),
            "description": obj.get("description"),
            "tutorial": obj.get("tutorial"),
            "owner": PutV1RunbooksRunbookIdOwner.from_dict(obj["owner"]) if obj.get("owner") is not None else None,
            "severities": [PutV1RunbooksRunbookIdSeveritiesInner.from_dict(_item) for _item in obj["severities"]] if obj.get("severities") is not None else None,
            "services": [PutV1RunbooksRunbookIdSeveritiesInner.from_dict(_item) for _item in obj["services"]] if obj.get("services") is not None else None,
            "environments": [PutV1RunbooksRunbookIdSeveritiesInner.from_dict(_item) for _item in obj["environments"]] if obj.get("environments") is not None else None,
            "attachment_rule": PostV1RunbooksAttachmentRule.from_dict(obj["attachment_rule"]) if obj.get("attachment_rule") is not None else None,
            "steps": [PutV1RunbooksRunbookIdStepsInner.from_dict(_item) for _item in obj["steps"]] if obj.get("steps") is not None else None,
            "auto_attach_to_restricted_incidents": obj.get("auto_attach_to_restricted_incidents")
        })
        return _obj


